package cn.ibizlab.assetmanagement.core.asset.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.asset.domain.EAMAssetState;
import cn.ibizlab.assetmanagement.core.asset.filter.EAMAssetStateSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMAssetState] 服务对象接口
 */
public interface IEAMAssetStateService extends IService<EAMAssetState>{

    boolean create(EAMAssetState et) ;
    void createBatch(List<EAMAssetState> list) ;
    boolean update(EAMAssetState et) ;
    void updateBatch(List<EAMAssetState> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMAssetState get(String key) ;
    EAMAssetState getDraft(EAMAssetState et) ;
    boolean checkKey(EAMAssetState et) ;
    boolean save(EAMAssetState et) ;
    void saveBatch(List<EAMAssetState> list) ;
    Page<EAMAssetState> searchDefault(EAMAssetStateSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMAssetState> getEamassetstateByIds(List<String> ids) ;
    List<EAMAssetState> getEamassetstateByEntities(List<EAMAssetState> entities) ;
}


